//          RAYSTAR Optronics, Inc. 
//=============================================================
//          WINSTAR Display Co.,Ltd
//    LCM     	 :WEO001602B 
//    Contraller :WS0012 
//    Author     : 2020/05/28
//    history     :4bit-6800-
//==============================================================
#include	<reg51.h>
#include 	<stdio.h>          // define I/O functions
#include 	<INTRINS.H>        // KEIL FUNCTION

// Interface type

#define Cword	0x10 //16
#define	one		0x80 // DD RAM Address 2A?@|a?X_cl|iMm0x00
						// cODH3]cwDD RAM|i}?X0x80+0x00=0x80	
#define	two		0xc0 // DD RAM Address 2A?G|a?X_cl|iMm0x40
						// cODH3]cwDD RAM|i}?X0x80+0x40=0xc0

#define	Data_BUS 	P1

sbit		busy    =P1^7;

sbit		RS      =P3^0; //for old test board
sbit	 	RW      =P3^7;
sbit		E  =P3^4;

sbit        STP = P2^0;
sbit        S_S = P2^1;

char bdata  flag;
sbit busy_f  = flag^0;

void WriteIns_WS0012(char);
void WriteCMD_WS0012(char);
void WriteData_WS0012(char);
void WriteIns4bit(unsigned char inst);
void Initial_WS0012_4bit();

unsigned char STC_MCU_IC;
void ReadMCUID(void);
void DelayX1ms(unsigned int second);
void stp_sc(void);
				  							  
unsigned char code MSG1[Cword]  ="ABCDEFGHIJKLMNOP";
unsigned char code MSG2[Cword]  ="ABCDEFGHIJKLMNOP";

unsigned char code CGRAM1[8] ={0x1F,0x11,0x11,0x11,0x11,0x11,0x11,0x1F,};
unsigned char code CGRAM2[8] ={0x0A,0x15,0x0A,0x15,0x0A,0x15,0x0A,0x15,};

unsigned int idata dat[80]={0};

void CheckBusy(void)
{
			Data_BUS = 0xff; //ç?high]nlow??N,?lh??nhigh.
			RS = 0;
			RW = 1;
	do
	{
 		
		  E = 1;
		  busy_f = 0;
			_nop_();
		  E = 0;
		  E = 1;
			_nop_();
		  E = 0;

	 }while(busy_f);
}
unsigned char ReadData(char instruction){
	unsigned char data1=0;
	
	WriteCMD_WS0012(instruction);
	
	Data_BUS = 0xff; //XTM1DNhighAU?Xlow?nMuReco,cODHDt3!3]?Xhigh.
	RS = 1;
	RW = 1;  

	E = 1;
	data1 = Data_BUS;
	E = 0;
	E = 1;
	data1 = Data_BUS;
	E = 0;	 
	return data1;	 
	DelayX1ms(1);
}
//==================================
void WriteIns4bit(unsigned char inst)
{
	 RS = 0;	 
	 RW = 0;
	 Data_BUS = inst&0xf0;
	 E = 1;      
	 _nop_();		//1us
	 E = 0;		
}
//=================================
void WriteIns_WS0012(char instruction){
//=======4bit==================	
	unsigned char hIns=instruction,lIns=instruction;
	 RS = 0;
	 RW = 0;
	 Data_BUS = hIns&0xf0;
	 E = 1;     
	 DelayX1ms(1);
	 E = 0;		
	 Data_BUS = lIns<<4;
	 E = 1;   
	 DelayX1ms(1);	
	 E = 0;	
//*/

		CheckBusy();
}

//=================================
void WriteCMD_WS0012(char instruction){
//=======4bit==================	
	unsigned char hIns=instruction,lIns=instruction;
	 RS = 0;
	 RW = 0;
	 Data_BUS = hIns&0xf0;
	 E = 1;     
	 _nop_();		//1us
	DelayX1ms(1);
	 E = 0;		
	 Data_BUS = lIns<<4;
	 E = 1;   
	 _nop_();		//1us
	DelayX1ms(1);
	 E = 0;	
//	*/ 
	CheckBusy();
}

//=================================
void WriteData_WS0012(char data1){
//=======4bit==================	
	unsigned char hIns=data1,lIns=data1;
	 RS = 1;
	 RW = 0;
	 Data_BUS = hIns&0xf0;
	 E = 1;     
	 _nop_();		//1us.
	DelayX1ms(1);
	 E = 0;		
	 Data_BUS = lIns<<4;
	 E = 1;       
	 _nop_();		//1us
	DelayX1ms(1);
	 E = 0;	
//*/
	CheckBusy();

}

//=========================================================
void DelayX1ms(unsigned int second) 
{
  unsigned int i;
     
  while(second--!=0)   
		if(STC_MCU_IC == 0)
			for (i=0; i<80; i++);				  			//For SyncMOS or Nuvoton MCU clock
		else
			for (i=0; i<580; i++);		   				//For STC12LE5A60S2 MCU clock
}

//=========================================================
void ReadMCUID()
{
	unsigned char i = 0;
	unsigned char	MCU_ID1[7] = {0xD1,0xFE,0x01,0x00,0x00,0x00,0x00}; 		//STC12LE5A60S2 1718HPP652.XA
	unsigned char	MCU_ID2[7] = {0xD1,0x7E,0x01,0x00,0x00,0x00,0x00}; 		//STC12C5A60S2
	unsigned char	MCU_ID3[7] = {0x00,0x03,0x00,0x00,0x00,0x00,0x00}; 		//STC12LE5A60S2 0914CY3948
	unsigned char	MCU_ID4[7] = {0xF5,0x28,0x00,0x00,0x00,0x00,0x00}; 		//STC15W4K56S4
	unsigned char	Read_MCU_ID[7]; 
	unsigned char idata *idata_point;
	
	idata_point = 0xF1; 
	for(i=0; i<=6; i++)
	{	
		Read_MCU_ID[i] = *idata_point; 
		idata_point++;	
	}
	if(Read_MCU_ID[0] == 0xD1 && Read_MCU_ID[1] == 0xFE)
	{
		STC_MCU_IC = 1;
	}
	else if(Read_MCU_ID[0] == 0xD1 && Read_MCU_ID[1] == 0x7E)
	{
		STC_MCU_IC = 1;
	}
	else if(Read_MCU_ID[0] == 0x00 && Read_MCU_ID[1] == 0x03)
	{
		STC_MCU_IC = 1;
	}
	else if(Read_MCU_ID[0] == 0xF5 && Read_MCU_ID[1] == 0x28)					//20171220 modified
	{
		STC_MCU_IC = 1;
	}
	else
	{
		STC_MCU_IC = 0;
	}
}

//===================================
// stp_sc();
//==================================
void stp_sc()
{
	 while(S_S==1)
	 {
		 if(S_S==0)
		 {
		     break;
		 }
		 if(STP==1)
		 {
		     break;
		 }
 	}
}

//=================================

void Initial_WS0012_4bit(){

	WriteIns4bit(0x00);
	WriteIns4bit(0x20);//function set //do it only once


	WriteIns_WS0012(0x28);//function set
//	CheckBusy();

	
	WriteIns_WS0012(0x0F);//Display Control		0	0	0	0	1	D	C	B
//	CheckBusy();

	
	WriteIns_WS0012(0x01);//clear display		
	DelayX1ms(1);		
	
	WriteIns_WS0012(0x02);//Return Home
	
	WriteIns_WS0012(0x06);//Entry Mode Set			0	0	0	0	0	1	I/D	S	
	
	//----table2-------	
	WriteIns_WS0012(0x03);//Entry Table 2	

	WriteIns_WS0012(0x2D);//Power control			0	0	1	0	BVR	DVR	DC2	DC1
	
	WriteIns_WS0012(0x00);//Exit Table 2
	//---------------

	WriteIns_WS0012(0x13);//C/G MODE / Sleep		0	0	0	1	GC	SLP	1	1	
	
	
	WriteIns_WS0012(0x16);//DISPLAY DIRECTION    		0	0	0	1	CMS	SHL	1	0
	

}
//==================================
void CGRAM()
{
	unsigned char i,j;
	
	 WriteCMD_WS0012(0x40);    //Ĥ@ӹϧΪCGRAM Address_l}000000(0x00)
					   //CGRAM}]w0x40+0x00=0x40
	for(i = 0;i<8;i++)
	{
	   	WriteData_WS0012(CGRAM1[i]);
	}
	
	 WriteCMD_WS0012(0x48);	   //ĤGӹϧΪCGRAM Address_l}001000(0x08)
					   //CGRAM}]w0x40+0x08=0x48
	for(j = 0;j<8;j++)
	{
	   	WriteData_WS0012(CGRAM2[j]); //data write to CGRAM

	}
}

void main(void){

	ReadMCUID();
	P2 = 0xFF;
	Initial_WS0012_4bit();
	CGRAM(); 
	DelayX1ms(10);
		
	while(1){

	unsigned char i;

	    WriteCMD_WS0012(one);
		for(i=0;i<16;i++)
		{
	    WriteData_WS0012(0xFF);
			}
	    WriteCMD_WS0012(two);
		for(i=0;i<16;i++)
		{
	    WriteData_WS0012(0xFF);
			}
		    DelayX1ms(1000);
	        stp_sc();

	    WriteCMD_WS0012(one);
		for(i=0;i<16;i++)
		{
	    WriteData_WS0012(0x20);
			}
	    WriteCMD_WS0012(two);
		for(i=0;i<16;i++)
		{
   	    WriteData_WS0012(0x20);
			}
 		    DelayX1ms(1000);
	        stp_sc();

		WriteCMD_WS0012(one);
		for(i=0;i<8;i++)
		{
	    WriteData_WS0012(0xFF);
		WriteData_WS0012(0x20);
			}
	    WriteCMD_WS0012(two);
		for(i=0;i<8;i++)
		{
   	    WriteData_WS0012(0x20);
		WriteData_WS0012(0xFF);
			}
 		    DelayX1ms(1000);
	        stp_sc();

		WriteCMD_WS0012(one);
		for(i = 0; i<Cword;i++){
		WriteData_WS0012(MSG1[i]);
			}
		WriteCMD_WS0012(two);
		for(i = 0; i<Cword;i++){
		WriteData_WS0012(MSG2[i]);
			}
		    DelayX1ms(1000);
	        stp_sc();

					
		WriteCMD_WS0012(one);
		for(i = 0; i<Cword;i++){
		WriteData_WS0012(0x00);
			}
		WriteCMD_WS0012(two);
		for(i = 0; i<Cword;i++){
		WriteData_WS0012(0x00);
			}
		    DelayX1ms(1000);
	        stp_sc();			
			
		WriteCMD_WS0012(one);
		for(i = 0; i<Cword;i++){
		WriteData_WS0012(0x01);
			}
		WriteCMD_WS0012(two);
		for(i = 0; i<Cword;i++){
		WriteData_WS0012(0x01);
			}
		    DelayX1ms(1000);
	        stp_sc();	
			
		WriteCMD_WS0012(one);
		for(i = 0; i<Cword;i++){
		WriteData_WS0012(0xB1);
			}
		WriteCMD_WS0012(two);
		for(i = 0; i<Cword;i++){
		WriteData_WS0012(0xB1);
			}
		    DelayX1ms(1000);
	        stp_sc();							
		}
	}


